import SDL;

struct Color {
    ubyte r, g, b;
}

Uint32 get_pixel(SDL_Surface* s, int x, int y) {
    Uint8* p = cast(Uint8*)s.pixels;
    Uint32* o = cast(Uint32*)(p + y * s.pitch + x * 3);
    return *o;
}

Color get_pixel_col(SDL_Surface* s, int x, int y) {
    Color c;
    SDL_GetRGB(get_pixel(s, x, y), s.format, &c.r, &c.g, &c.b);
    return c;
}

Color get_col(SDL_Surface* s, Uint32 p) {
    Color c;
    SDL_GetRGB(p, s.format, &c.r, &c.g, &c.b);
    return c;
}

void print_color(Color c) {
    printf("%d %d %d\n", c.r, c.g, c.b);
}

void main() {
    SDL_Init(SDL_INIT_VIDEO);
    SDL_Surface* t = SDL_LoadBMP(`target.bmp`);
    for (int y = 0; y < 600; y++) {
        int[int] histogram;
        int max, max_p;
        for (int x = 0; x < 600; x++) {
            Color c = get_pixel_col(t, x, y);
            int p = c.r + c.g * 256 + c.b * 256 * 256;
            if (p in histogram) {
                histogram[p]++;
                if (max < histogram[p]) {
                    max = histogram[p];
                    max_p = p;
                }
            }
            else {
                histogram[p] = 1;
            }
        }
        printf("%d %d ", y, max);
        int k = max_p;
        printf("r=%d g=%d b=%d\n", k % 256, k / 256 % 256, k / 256 / 256);
    }
}
