def asnat(n)
  r = ''
  while n > 0
    if (n & 1) == 0
      r += 'I'
    else
      r += 'C'
    end
    n >>= 1
  end
  r += 'P'
end

dna = ''
px = 0
py = 0
dir = :S

prev_dna_len = 0
prev_name = 'start'
l = proc{|s|
  STDERR.puts("#{prev_name}: #{dna.size-prev_dna_len}")
  prev_name = s
  prev_dna_len=dna.size
}

blue = proc{dna += 'III'+'PIPIICP'}
white = proc{dna += 'III'+'PIPIIPC'}
cyan = proc{dna += 'III'+'PIPIIFF'}
yellow = proc{dna += 'III'+"PIPIICF"}
red = proc{dna += 'III'+"PIPIIIP"}
green = proc{dna += 'III'+"PIPIICC"}
black = proc{dna += 'III'+"PIPIIIC"}
magenta = proc{dna += 'III'+"PIPIIFC"}

fill = proc{dna += 'III'+'PIIPIIP'}

ccw = proc{dna += 'III'+'PCCCCCP'}
cw = proc{dna += 'III'+'PFFFFFP'}
move = proc{dna += 'III'+'PIIIIIP'}
mark = proc{dna += 'III'+'PCCIFFP'}
line = proc{dna += 'III'+'PFFICCP'}
clear = proc{dna += 'III'+"PIIPICP"}

add_bmp = proc{dna += 'III'+"PCCPFFP"}
compose = proc{dna += 'III'+"PFFPCCP"}
clip = proc{dna += 'III'+"PFFICCF"}

CMDS = {
  :blue => 'III'+'PIPIICP',
  :white => 'III'+'PIPIIPC',
  :cyan => 'III'+'PIPIIFF',
  :yellow => 'III'+"PIPIICF",
  :red => 'III'+"PIPIIIP",
  :green => 'III'+"PIPIICC",
  :black => 'III'+"PIPIIIC",
  :magenta => 'III'+"PIPIIFC",
  :move => 'III'+'PIIIIIP',
  :trans => 'III'+"PIPIIPF",
  :opaque=>'III'+"PIPIIPP",
}
MOVE = CMDS[:move]
LINE = 'III'+'PFFICCP'
MARK = 'III'+'PCCIFFP'
CCW = 'III'+'PCCCCCP'
CW = 'III'+'PFFFFFP'
BLACK = 'III'+"PIPIIIC"
WHITE = 'III'+'PIPIIPC'
CYAN = CMDS[:cyan]

def week_compress(c, i)
  x = ''
  x += 'IIPIP'+asnat(c.size)+'IIFIIF'
  x += 'IFPP' * i + 'IIF'
  x += c
  x
end

def strong_compress(c, i)
  l = 0
  while (c + asnat(l) + 'IIPIP' + 'IIFFIIFIFPPIFPPIIF').size != l
    l += 1
  end
  x = ''
  x += 'IIPIP' + asnat(l) + 'IIFIIFIFPPIFPPIIF'
  x += (c + 'IIPIP' + asnat(l) + 'IIFFIIFIFPPIFPPIIF') + 'C' * (i - 2)
  x
end

$border = 32
BLACKLIST = [ 101, 92, 54, 49, 48, 46, 37, 33 ]
add = proc {|c, i, *border|
  if border.size == 0
    border = $border
  else
    border = border[0]
  end
  c = CMDS[c]
  if (i < 5)
    dna += c * i
  elsif (i < border || BLACKLIST.index(i))
  #elsif (true)
    dna += week_compress(c, i)
  else
    dna += strong_compress(c, i)
    #dna += (c + 'IIPIPIIICICPIIFFIIFIFPPIFPPIIF') * 2 + 'C' * (i - 1)
    #dna += 'IIPIPCIICCPIIF'
    #dna += ''
  end
}

chdir = proc{|d|
  case d
  when :E
    case dir
    when :E
    when :W
      cw[];cw[]
    when :N
      cw[]
    when :S
      ccw[]
    end
  when :W
    case dir
    when :E
      cw[];cw[]
    when :W
    when :N
      ccw[]
    when :S
      cw[]
    end
  when :N
    case dir
    when :E
      ccw[]
    when :W
      cw[]
    when :N
    when :S
      cw[];cw[]
    end
  when :S
    case dir
    when :E
      cw[]
    when :W
      ccw[]
    when :N
      cw[];cw[]
    when :S
    end
  end
  dir = d
}

goto = proc{|x,y|
  dx = x-px
  dy = y-py
  case dir
  when :E
    if dx > 0
      add[:move, dx]
    end
    roll = nil
    if dy > 0
      roll = cw
      roll[]
      add[:move, dy]
      dir = :S
    elsif dy < 0
      roll = ccw
      roll[]
      add[:move, -dy]
      dir = :N
    else
      roll = proc{cw[];cw[]}
    end
    if dx < 0
      roll[]
      add[:move, -dx]
      dir = :W
    end
  when :W
    if dx < 0
      add[:move, -dx]
    end
    roll = nil
    if dy > 0
      roll = ccw
      roll[]
      add[:move, dy]
      dir = :S
    elsif dy < 0
      roll = cw
      roll[]
      add[:move, -dy]
      dir = :N
    else
      roll = proc{cw[];cw[]}
    end
    if dx > 0
      roll[]
      add[:move, dx]
      dir = :E
    end
  when :S
    if dy > 0
      add[:move, dy]
    end
    roll = nil
    if dx > 0
      roll = ccw
      roll[]
      add[:move, dx]
      dir = :E
    elsif dx < 0
      roll = cw
      roll[]
      add[:move, -dx]
      dir = :W
    else
      roll = proc{cw[];cw[]}
    end
    if dy < 0
      roll[]
      add[:move, -dy]
      dir = :N
    end
  when :N
    if dy < 0
      add[:move, -dy]
    end
    roll = nil
    if dx > 0
      roll = cw
      roll[]
      add[:move, dx]
      dir = :E
    elsif dx < 0
      roll = ccw
      roll[]
      add[:move, -dx]
      dir = :W
    else
      roll = proc{cw[];cw[]}
    end
    if dy > 0
      roll[]
      add[:move, dy]
      dir = :S
    end
  end
  px = x
  py = y
}

#3426220

# --- sky ---
l['sky']

cw[]
add[:white, 21]
add[:cyan, 37]
add[:blue, 9]
fill[]

clear[]
add[:white, 29]
add[:cyan, 4]
add[:blue, 1]

# --- cloud 1 ---
l['cloud 1']

#add_bmp[]
goto[0,64]
mark[]
goto[20,57]
line[]
mark[]
goto[86,53]
line[]
mark[]
goto[86,28]
line[]
mark[]
goto[37,28]
line[]
mark[]
goto[20,57]
line[]
goto[22,55]
fill[]

clear[]
add[:white,26]
add[:cyan,4]
add[:blue,1]
mark[]
goto[24,75]
line[]
mark[]
goto[103,75]
line[]
mark[]
goto[86,53]
line[]
mark[]
goto[80,60]
fill[]
# goto[27,73]
# line[]
# mark[]
# goto[107,73]
# line[]
# mark[]
# goto[107,29]
# line[]
# mark[]
# goto[39,29]
# line[]
# mark[]
# goto[31,57]
# line[]
goto[94,48]
line[]
#fill[]
#compose[]

clear[]
add[:white, 11]
add[:cyan, 28]
add[:blue, 7]

mark[]
goto[190,65]
line[]
mark[]
goto[272,36]
line[]
mark[]
goto[330,23]
line[]
mark[]
goto[421,20]
line[]
mark[]
goto[522,45]
line[]
mark[]
goto[599,75]
line[]
goto[599,91]
fill[]

# --- cloud 2 ---
l['cloud 2']

clear[]
add[:white, 25]
add[:cyan, 4]
add[:blue, 1]
mark[]
goto[498,109]
line[]

mark[]
goto[458,112]
line[]
mark[]
goto[348,104]
line[]
mark[]
goto[338,80]
line[]
mark[]
goto[360,34]
line[]
mark[]
goto[448,32]
line[]
mark[]
goto[454,59]
line[]
mark[]
goto[470,78]
line[]
mark[]
goto[465,95]
line[]
mark[]
goto[344,95]
line[]
goto[362,92]
fill[]

goto[348,104]

# --- cloud 3 ---
l['cloud 3']

clear[]
add[:white,25]
add[:cyan,4]
add[:blue,1]
mark[]
goto[186,65]
line[]
mark[]
goto[190,55]
line[]
mark[]
goto[233,55]
line[]
mark[]
goto[245,79]
line[]
goto[243,76]
fill[]

clear[]
add[:white,23]
add[:cyan,4]
add[:blue,1]
mark[]
goto[242,88]
line[]
mark[]
goto[182,88]
line[]
mark[]
goto[182,88]
line[]
mark[]
goto[186,65]
line[]
goto[186,69]
fill[]

goto[186,64]

clear[]
add[:white, 14]
add[:cyan, 33]
add[:blue, 8]
#mark[]
#goto[190,65]
#line[]
mark[]
goto[86,110]
line[]
mark[]
goto[0,98]
line[]

goto[0,97]
fill[]

ccw[]
move[]
dir = :W; px = 599; py = 97

# --- sun ---
l['goto sun']

add_bmp[]
clear[]
add[:white,11]
add[:yellow,20]
add[:red,1]
goto[573,95]
l['sun']
mark[]
goto[550,76]
line[];mark[]
goto[580,70]
line[];mark[]
goto[550,64]
line[];mark[]
goto[573,45]
line[];mark[]
goto[544,56]
line[];mark[]
goto[555,28]
line[];mark[]
goto[536,50]
line[];mark[]
goto[530,20]
line[];mark[]
goto[525,50]
line[];mark[]
goto[505,27]
line[];mark[]
goto[516,56]
line[];mark[]
goto[487,45]
line[];mark[]
goto[510,64]
line[];mark[]
goto[480,70]
line[];mark[]
goto[510,76]
line[];mark[]
goto[487,95]
line[];mark[]
goto[516,84]
line[];mark[]
goto[505,113]
line[];mark[]
goto[524,90]
line[];mark[]
goto[530,120]
line[];mark[]
goto[536,90]
line[];mark[]
goto[555,113]
line[];mark[]
goto[544,84]
line[];mark[]
goto[573,95]
line[]
goto[530,95]
fill[]
compose[]

goto[599,95]
move[]
px=0

clear[]
add[:white, 15]
add[:cyan, 58]
add[:blue, 14]
goto[0,142]
fill[]

clear[]
add[:white, 9]
add[:cyan, 32]
add[:blue, 8]

mark[]
goto[86,110]
line[]

goto[80,110]
fill[]

clear[]
add[:white, 9]
add[:cyan, 70]
add[:blue, 17]

mark[]
goto[243,153]
line[]
mark[]
goto[345,159]
line[]
mark[]
goto[502,146]
line[]
mark[]
goto[599,147]
line[]
goto[599,239]
fill[]

# --- mountain 1 ---
l['mountain 1']

clear[]
add[:black, 25]
add[:white, 20]
add[:yellow, 8]
add[:green, 37]
mark[]
chdir[:E]
move[]
dir=:E;px=0;py=239
line[]
goto[0,219]
mark[]
goto[41,197]
line[]
mark[]
goto[81,184]
line[]
mark[]
goto[184,206]
line[]
mark[]
goto[184,238]
line[]
goto[183,238]
fill[]

# --- mountain 2 ---
l['mountain 2']

clear[]
add[:black, 43]
add[:white, 3]
add[:cyan, 10]
add[:green, 45]
mark[]
goto[249,196]
line[];mark[]
goto[286,178]
line[];mark[]
goto[331,178]
line[];mark[]
goto[378,197]
line[];mark[]
goto[426,220]
line[]
mark[]
goto[388,238]
line[]
goto[387,238]
fill[]

# --- mountain 3 ---
l['mountain 3']

clear[]
add[:black, 25]
add[:white, 20]
add[:yellow, 8]
add[:green, 37]
mark[]
goto[449,211]
line[]
mark[]
goto[549,195]
line[]
mark[]
goto[599,216]
line[]
goto[599,217]
fill[]

#chdir[:E]
#move[]

chdir[:E]
move[]
dir=:E;px=0;py=217

compose[]

goto[0,239]
#fill[]
chdir[:S]

# mark[]
# goto[300,80]
# line[]
# mark[]
# #chdir[:S]
# goto[0,60]
# line[]
# goto[0,90]




# cw[]
# move[]
# line[]
# ccw[]
# move[]
# fill[]

# # clear[]
# # 25.times{white[]}
# # 4.times{cyan[]}
# # 1.times{blue[]}
# # 24.times{move[]}
# # mark[]
# # ccw[]
# # move[]
# # line[]
# # cw[]
# # move[]
# # fill[]

# #105
# clear[]
# add[:white, 15]
# add[:cyan, 58]
# add[:blue, 14]
# add[:move, 62]
# mark[]
# ccw[]
# #move[]
# line[]
# cw[]
# move[]
# fill[]

# #149
# clear[]
# add[:white, 9]
# add[:cyan, 70]
# add[:blue, 17]
# add[:move, 43]
# mark[]
# cw[]
# move[]
# line[]
# ccw[]
# move[]
# fill[]

# #212
# clear[]
# add[:black, 25]
# add[:white, 20]
# add[:yellow, 8]
# add[:green, 37]
# add[:move, 62]
# mark[]
# ccw[]
# move[]
# line[]
# cw[]
# move[]
# fill[]

#goto[0,213]
#chdir[:S]
#clear[]
#add[:move, 26]

# --- GREEN ---
l['green']

clear[]
add[:black, 450]
#add[:green, 150]
dna += strong_compress(CMDS[:green], 150)

mark[]
cw[]
move[]
ccw[]

dna += strong_compress('III'+'PFFICCP'+CMDS[:move]+CMDS[:green], 360)
cw[]
dna += strong_compress('III'+'PFFICCP'+CMDS[:move]+CMDS[:green], 600)

dir=:W
px = 599
py = 599

# --- endo ---
l['endo']

add_bmp[]

clear[]
add[:white,70]
add[:magenta,16]
add[:blue,1]
goto[340,402]
mark[]
goto[327,398]
line[];mark[]
goto[315,410]
line[];mark[]
goto[320,422]
line[];mark[]
goto[333,422]
line[];mark[]
goto[341,410]
line[];mark[]
goto[340,402]
line[]
goto[338,404]
fill[]

goto[263,408]
mark[]
goto[250,418]
line[];mark[]
goto[250,429]
line[];mark[]
goto[258,435]
line[];mark[]
goto[272,431]
line[];mark[]
goto[274,416]
line[];mark[]
goto[263,408]
line[]
goto[263,409]
fill[]

clear[]
add[:black,4]
add[:white,1]
goto[317,465]
mark[]
goto[260,465]
line[];mark[]
goto[243,483]
line[];mark[]
goto[312,486]
line[];mark[]
goto[317,465]
line[]
goto[315,467]
fill[]
compose[]

add_bmp[]

clear[]
white[]

goto[289,475]
mark[]
goto[243,479]
line[];mark[]
goto[231,490]
line[];mark[]
goto[262,512]
line[];mark[]
goto[289,496]
line[];mark[]
goto[289,475]
line[]
goto[287,477]
fill[]

goto[407,505]
mark[]
goto[380,488]
line[];mark[]
goto[380,489]
line[];mark[]
goto[332,489]
line[];mark[]
goto[309,518]
line[];mark[]
goto[334,545]
line[];mark[]
goto[375,545]
line[];mark[]
goto[411,526]
line[];mark[]
goto[407,505]
line[]
goto[405,507]
fill[]

# --- endo foot ---
l['endo foot']

clear[]
add[:white,33]
add[:yellow,3]
add[:green,5]
goto[303,558]
mark[]
goto[273,558]
line[];mark[]
goto[273,545]
line[];mark[]
goto[293,542]
line[];mark[]
goto[303,558]
line[]
goto[301,557]
fill[]

goto[348,558]
mark[]
goto[344,568]
line[];mark[]
goto[371,568]
line[];mark[]
goto[367,557]
line[];mark[]
goto[348,558]
line[]
goto[349,559]
fill[]

goto[399,554]
mark[]
goto[400,562]
line[];mark[]
goto[431,562]
line[];mark[]
goto[431,549]
line[];mark[]
goto[406,548]
line[];mark[]
goto[399,554]
line[]
goto[400,555]
fill[]

add_bmp[]
clear[]
goto[336,486]
mark[]
goto[332,521]
line[];mark[]
goto[352,527]
line[];mark[]
goto[375,507]
line[];mark[]
goto[364,490]
line[];mark[]
goto[336,486]
line[]
goto[338,488]
fill[]

goto[377,482]
mark[]
goto[381,507]
line[];mark[]
goto[390,512]
line[];mark[]
goto[411,502]
line[];mark[]
goto[404,484]
line[];mark[]
goto[377,482]
line[]
goto[379,484]
fill[]

compose[]

# --- C++ ---
l['C++']

clear[]
add[:black,9]
add[:white,18]
add[:yellow,30]
add[:red,34]
goto[599,528]
mark[]
goto[552,542]
line[]
mark[]
goto[517,482]
line[]
mark[]
goto[484,449]
line[]
mark[]
goto[536,388]
line[]
mark[]
goto[599,359]
line[]
goto[599,363]
fill[]

add_bmp[]
clear[]
add[:black,41]
add[:white,10]
goto[599,451]
mark[]
goto[540,466]
line[];mark[]
goto[535,486]
line[];mark[]
goto[550,498]
line[];mark[]
#goto[562,459]
#line[];mark[]
#goto[565,492]
#line[];mark[]
goto[599,477]
line[]
goto[599,476]
fill[]

compose[]

goto[599,599]

compose[]
compose[]

# --- tower ---
l['tower']

add_bmp[]

move[]
ccw[]
move[]

dir = :E; px = 0; py = 0

goto[183,149]
chdir[:S]
clear[]
add[:black,45]
add[:red,55]
dna += week_compress(MARK+strong_compress(MOVE,64)+
                     LINE+CCW+MOVE+CCW+BLACK+
                     MARK+strong_compress(MOVE,63)+
                     LINE+CW+MOVE+CW+BLACK,
                     18)
cw[]
add[:move,37]
cw[]
add[:move,18]
ccw[]
ccw[]
clear[]
add[:black,45]
add[:red,55]
dna += week_compress(MARK+strong_compress(MOVE,64)+
                     LINE+CW+MOVE+CW+BLACK+
                     MARK+strong_compress(MOVE,63)+
                     LINE+CCW+MOVE+CCW+BLACK,
                     16)
px -= 33
py += 16

# --- train ---
l['train']

clear[]
add[:black,3]
add[:white,27]
add[:cyan,3]
add[:blue,2]
goto[275,223]
mark[]
goto[275,237]
line[];mark[]
goto[307,237]
line[];mark[]
goto[307,223]
line[];mark[]
goto[275,223]
line[]
goto[276,224]
fill[]

clear[]
add[:black,8]
add[:white,22]
add[:yellow,9]
add[:red,26]
goto[315,223]
mark[]
goto[315,251]
line[];mark[]
goto[332,251]
line[];mark[]
goto[332,223]
line[];mark[]
goto[315,223]
line[]
goto[316,224]
fill[]

clear[]
add[:black,4]
add[:white,40]
add[:cyan,7]
add[:blue,5]
goto[340,223]
mark[]
goto[340,237]
line[];mark[]
goto[357,237]
line[];mark[]
goto[357,223]
line[];mark[]
goto[340,223]
line[]
goto[341,224]
fill[]

# --- kujira ---
l['kujira']

clear[]
add[:black,3]
add[:white,47]
add[:cyan,13]
add[:blue,8]
goto[420,266]
mark[]
goto[478,266]
line[];mark[]
goto[478,284]
line[];mark[]
goto[457,314]
line[];mark[]
goto[443,314]
line[];mark[]
goto[425,295]
line[];mark[]
goto[420,266]
line[]
goto[422,268]
fill[]

clear[]
add[:black,5]
add[:white,12]
goto[442,261]
mark[]
goto[474,261]
line[];mark[]
goto[474,250]
line[];mark[]
goto[462,241]
line[];mark[]
goto[442,241]
line[];mark[]
goto[442,261]
line[]
goto[443,260]
fill[]

# --- tree ---
l['tree']

add_bmp[]
# @@@ can decrease?
clear[]
add[:black,30]
add[:white,5]
add[:yellow,13]
add[:red,18]

goto[518,199]
mark[]
goto[516,264]
line[];mark[]
goto[527,264]
line[];mark[]
goto[527,199]
line[];mark[]
goto[518,199]
line[]
goto[520,200]
fill[]

goto[538,219]
mark[]
goto[537,285]
line[];mark[]
goto[547,285]
line[];mark[]
goto[547,219]
line[];mark[]
goto[538,219]
line[]
goto[540,220]
fill[]

goto[559,216]
mark[]
goto[557,270]
line[];mark[]
goto[567,270]
line[];mark[]
goto[569,216]
line[];mark[]
goto[559,216]
line[]
goto[561,218]
fill[]

compose[]

add_bmp[]
clear[]
add[:opaque,3]
add[:trans,1]
add[:green,44]
add[:black,43]

goto[504,200]
mark[]
goto[528,229]
line[];mark[]
goto[560,229]
line[];mark[]
goto[586,207]
line[];mark[]
goto[586,177]
line[];mark[]
goto[504,177]
line[];mark[]
goto[504,200]
line[]
goto[507,200]
fill[]

compose[]

# --- body ---

add_bmp[]
clear[]
yellow[]
red[]
goto[192,214]
mark[]
goto[145,212]
line[];mark[]
goto[153,222]
line[];mark[]
goto[187,224]
line[];mark[]
goto[192,214]
line[]
goto[183,221]
fill[]
compose[]

l['T body']

goto[184,222]
chdir[:S]

clear[]
dna += strong_compress(WHITE,150)

dna += week_compress(MARK+strong_compress(MOVE,117)+
                     LINE+CCW+MOVE+CCW+BLACK+
                     MARK+strong_compress(MOVE,117)+
                     LINE+CW+MOVE+CW+BLACK,
                     17)

cw[]
add[:move,35]
ccw[]

clear[]
dna += strong_compress(WHITE,150)

dna += week_compress(MARK+strong_compress(MOVE,117)+
                     LINE+CW+MOVE+CW+BLACK+
                     MARK+strong_compress(MOVE,117)+
                     LINE+CCW+MOVE+CCW+BLACK,
                     16)

#dna += week_compress(MARK+MOVE*120+LINE+CCW+MOVE+CCW+MARK+MOVE*120+LINE+CW+MOVE+CW, 20)

px -= 33

# --- foot ---
l['T foot']

goto[184,222+117+1]
chdir[:S]

FOOT_HEIGHT = 71

clear[]
add[:black,36]
add[:blue,44]
dna += strong_compress(MARK+strong_compress(MOVE,FOOT_HEIGHT)+
                     LINE+CCW+MOVE+CCW+BLACK+
                     MARK+strong_compress(MOVE,FOOT_HEIGHT)+
                     LINE+CW+MOVE+CW+BLACK,
                     19)
cw[]
add[:move,39]
ccw[]
clear[]
add[:black,36]
add[:blue,44]
dna += strong_compress(MARK+strong_compress(MOVE,FOOT_HEIGHT)+
                     LINE+CW+MOVE+CW+BLACK+
                     MARK+strong_compress(MOVE,FOOT_HEIGHT)+
                     LINE+CCW+MOVE+CCW+BLACK,
                     19)
px -= 39

# --- window ---
l['T window']

# add_bmp[]
# clear[]
# goto[174,363]
# mark[]
# goto[191,363]
# line[];mark[]
# goto[191,388]
# line[];mark[]
# goto[174,388]
# line[];mark[]
# goto[174,364]
# line[]
# goto[175,364]
# add[:black,27]
# add[:white,43]
# add[:cyan,12]
# add[:blue,29]
# fill[]
# compose[]

compose[]

goto[183,173]

chdir[:S]

clear[]
add[:white,19]
add[:black,3]

# --- fan ---
l['T fan']

add_bmp[]

draw_fan = proc{
  mark[]
  goto[283,309]
  line[];mark[]
  goto[279,316]
  line[];mark[]
  goto[255,319]
  line[];mark[]
  goto[225,282]
  line[];mark[]
  goto[219,257]
  line[];mark[]
  goto[189,221]
  line[];mark[]
  goto[212,210]
  line[]
  goto[212,220]
  fill[]
  goto[183,173]

#   mark[]
#   goto[283,309]
#   line[];mark[]
#   goto[256,318]
#   line[];mark[]
#   goto[189,221]
#   line[];mark[]
#   goto[212,210]
#   line[]
#   goto[212,220]
#   fill[]
#   goto[183,173]

#   # 183,173 - 283, 309
#   mark[]
#   add[:move,136]
#   ccw[]
#   #add[:move,100]
#   dna+=strong_compress(MOVE,100)
#   line[]
#   # 283, 309 - 256, 318
#   mark[]
#   cw[]
#   add[:move,9]
#   cw[]
#   add[:move,27+8]
#   line[]
#   # 256, 318 - 189, 221
#   mark[]
#   add[:move,67-8]
#   cw[]
#   add[:move,97]
#   line[]
#   # 189, 221 - 212, 210
#   mark[]
#   add[:move,11]
#   cw[]
#   add[:move,23]
#   line[]
#   cw[]
#   # - 212, 220
#   add[:move,10]
#   fill[]
#   # - 183,173
#   cw[]
#   add[:move,29]
#   cw[]
#   add[:move,47]
}

draw_fan2 = proc{
  # 183,173 - 83, 37
  mark[]
  add[:move,136]
  ccw[]
  #add[:move,100]
  dna+=strong_compress(MOVE,100)
  line[]
  # 83, 37 - 256, 318
  mark[]
  cw[]
  add[:move,9+11]
  cw[]
  add[:move,35-11]
  line[]
  # 256, 318 - 189, 221
  mark[]
  add[:move,59+11]
  cw[]
  add[:move,97+11]
  line[]
  # 189, 221 - 212, 210
  mark[]
  add[:move,11]
  cw[]
  add[:move,23]
  line[]
  cw[]
  # - 212, 220
  add[:move,10]
  fill[]
  # - 183,173
  cw[]
  add[:move,29]
  cw[]
  add[:move,47]
}

draw_fan3 = proc{
  # 183,173 - 83, 37
  mark[]
  add[:move,136]
  ccw[]
  #add[:move,100]
  dna+=strong_compress(MOVE,100)
  line[]
  px = 83; py = 37; dir = :W
  mark[]
  goto[86,28]
  line[];mark[]
  goto[98,28]
  line[];mark[]
  goto[107,17]
  line[];mark[]
  goto[133,46]
  line[];mark[]
  goto[152,91]
  line[];mark[]
  goto[177,125]
  line[];mark[]
  goto[161,125]
  line[];mark[]
  goto[154,135]
  line[]
  goto[154,126]
  fill[]
  goto[183,173]
}

draw_fan[]
draw_fan3[]
cw[]
draw_fan3[]
draw_fan3[]

dir=:W;px=183;py=173

compose[]

# --- stick --- @@@ can concat to fan
l['T stick']

add_bmp[]

clear[]
add[:black,37]
add[:white,14]
add[:yellow,15]
add[:red,16]

goto[183,167]
mark[]
goto[82,36]
line[];mark[]
goto[75,41]
line[];mark[]
goto[177,172]
line[];mark[]
goto[46,273]
line[];mark[]
goto[51,280]
line[];mark[]
goto[51,280]
line[];mark[]
goto[182,178]
line[];mark[]
goto[283,309]
line[];mark[]
goto[290,304]
line[];mark[]
goto[188,173]
line[];mark[]
goto[319,72]
line[];mark[]
goto[314,65]
line[];mark[]
goto[183,167]
line[]
goto[183,168]
fill[]

#compose[]

# --- birds ---
l['birds']

clear[]
add[:black,1]
add[:yellow,14]
goto[110,325]
mark[]
goto[110,339]
line[]
mark[]
goto[87,339]
line[]
mark[]
goto[87,325]
line[]
mark[]
goto[109,325]
line[]
goto[109,326]
fill[]

# --- river ---
l['river']

clear[]
add[:black,1]
add[:yellow,14]
goto[75,300]
mark[]
goto[20,295]
line[]
mark[]
goto[26,326]
line[]
mark[]
goto[68,326]
line[]
mark[]
goto[75,301]
line[]
goto[74,302]
fill[]

add_bmp[]

clear[]
add[:black,15]
add[:cyan,8]

goto[0,335]
mark[]
goto[0,384]
line[];mark[]
goto[50,384]
line[];mark[]
goto[1,336]
line[]
goto[1,337]
fill[]

# --- arch 2 ---
l['arch 2']

add_bmp[]
clear[]
add[:black,23]
add[:white,4]
add[:red,12]
goto[0,385]
mark[]
goto[0,385]
line[];mark[]
goto[0,412]
line[];mark[]
goto[0,412]
line[];mark[]
goto[90,412]
line[];mark[]
goto[90,385]
line[];mark[]
goto[70,385]
line[];mark[]
goto[41,365]
line[];mark[]
goto[11,385]
line[];mark[]
goto[1,385]
line[]
goto[1,386]
fill[]
compose[]

add_bmp[]
clear[]
add[:black,1]
add[:white,1]
goto[9,416]
mark[]
goto[30,394]
line[];mark[]
goto[51,394]
line[];mark[]
goto[54,396]
line[];mark[]
goto[29,416]
line[];mark[]
goto[9,416]
line[]
goto[13,414]
fill[]
compose[]

# --- river grad ---
l['river grad']

clear[]
add[:black,300]
goto[20,419]
mark[]

add_bmp[]

#add[:cyan,150]
#goto[240,599]
#chdir[:W]
goto[240,569-150]
chdir[:S]
dna += strong_compress(LINE+MOVE+CYAN,180)
cw[]
dna += strong_compress(LINE+MOVE+CYAN,81)

dir = :W
px = 240-81
py = 599


# clip
add_bmp[]
clear[]
dna+=CMDS[:opaque]
fill[]
clear[]
dna+=CMDS[:trans]
goto[241,599]
mark[]
goto[62,410]
line[];mark[]
# ??????
tmp_border = $border
$border = 200
goto[241,410]
$border = tmp_border
line[];mark[]
goto[241,599]
line[]
goto[239,596]
fill[]
clip[]

compose[]

add_bmp[]

clear[]
add[:black,10]
add[:yellow,21]
add[:green,21]
goto[148,599]
mark[]
goto[148,574]
line[];mark[]
goto[33,466]
line[];mark[]
goto[10,460]
line[];mark[]
goto[148,599]
line[]
goto[140,582]
fill[]

compose[]

# --- arch ---
l['arch']

add_bmp[]

clear[]
add[:black,29]
add[:white,9]
add[:red,26]

goto[0,417]
mark[]
goto[30,417]
line[];mark[]
goto[55,397]
line[];mark[]
goto[79,397]
line[];mark[]
goto[96,417]
line[]
mark[]
goto[118,417]
line[]
mark[]
goto[118,446]
line[];mark[]
goto[96,446]
line[];mark[]
goto[63,422]
line[];mark[]
goto[0,446]
line[]
goto[0,445]
fill[]

compose[]

compose[]

compose[]

# --- noise ---
l['noise']

goto[0,599]
chdir[:W]
move[]
px=599

add_bmp[]

goto[599,599]
chdir[:S]

move[]
ccw[]
move[]

mark[]
clear[]
add[:opaque,1]
dna+=week_compress(CMDS[:trans],63)
ccw[]
move[]
cw[]
dna += strong_compress(week_compress(CMDS[:move],15)+'III'+'PFFICCP'+MOVE*5, 30)
ccw[]
ccw[]
move[]
cw[]
dna += strong_compress(MOVE*4+'III'+'PFFICCP'+MOVE*16, 30)

add[:blue,1]
dna += strong_compress(week_compress(CMDS[:move],19)+'III'+'PFFICCP'+MOVE, 30)
ccw[]
dna += strong_compress(week_compress(CMDS[:move],19)+'III'+'PFFICCP'+MOVE, 30)

add[:black,2]
dna += strong_compress(MOVE*9+LINE+MOVE*5+LINE+MOVE*6, 30)
cw[]
dna += strong_compress(MOVE*9+LINE+MOVE*5+LINE+MOVE*6, 30)


clear[]
mark[]
cw[]
move[]
ccw[]
move[]
move[]
move[]
move[]
add[:opaque,1]
dna+=week_compress(CMDS[:trans],63)
#63.times{add[:trans,1]}
#63.times{add[:black,1]}
#black[]
#black[]
#add[:blue,1]
#dna += strong_compress('III'+'PFFICCP'+CMDS[:move]*20, 29)
dna += strong_compress('III'+'PFFICCP'+week_compress(CMDS[:move],20), 29)
add[:move,15]
cw[]
#add[:move,15]
dna += strong_compress(week_compress(CMDS[:move],15)+'III'+'PFFICCP'+CMDS[:move]*5, 30)
#add[:move,5]
add[:blue,1]
dna += strong_compress('III'+'PFFICCP'+CMDS[:move]*20, 30)
ccw[]
dna += strong_compress('III'+'PFFICCP'+week_compress(CMDS[:move],20), 30)
add[:black,2]
dna += strong_compress(week_compress(CMDS[:move],10)+'III'+'PFFICCP'+CMDS[:move]*5+'III'+'PFFICCP'+CMDS[:move]*5, 30)

cw[]
dna += strong_compress(CMDS[:move]*5+'III'+'PFFICCP'+CMDS[:move]*5+'III'+'PFFICCP'+week_compress(CMDS[:move],10), 30)



l['done']


compose[]


dna += 'IP' + asnat(7523060) + 'IIC'
dna += 'IIC'

print dna
