import SDL;
import std.string;

struct Color {
    ubyte r, g, b;
}

Uint32 get_pixel(SDL_Surface* s, int x, int y) {
    Uint8* p = cast(Uint8*)s.pixels;
    Uint32* o = cast(Uint32*)(p + y * s.pitch + x * 3);
    return *o;
}

Color get_pixel_col(SDL_Surface* s, int x, int y) {
    Color c;
    SDL_GetRGB(get_pixel(s, x, y), s.format, &c.r, &c.g, &c.b);
    return c;
}

Color get_col(SDL_Surface* s, Uint32 p) {
    Color c;
    SDL_GetRGB(p, s.format, &c.r, &c.g, &c.b);
    return c;
}

void print_color(Color c) {
    printf("%d %d %d\n", c.r, c.g, c.b);
}

void main(char[][] args) {
    SDL_Init(SDL_INIT_VIDEO);
    //SDL_Surface* s = SDL_LoadBMP(`target.bmp`);
    SDL_Surface* s = SDL_LoadBMP(`endo.bmp`);
    if (args.length > 1) {
        s = SDL_LoadBMP(toStringz(args[1]));
    }
    for (int i = 0; i < 600; i++) {
        printf("%d ", i);
        print_color(get_pixel_col(s, 530, i));
        //print_color(get_pixel_col(s, i, 200));
    }
}

