import SDL;

struct Color {
    ubyte r, g, b;
}

Uint32 get_pixel(SDL_Surface* s, int x, int y) {
    Uint8* p = cast(Uint8*)s.pixels;
    Uint32* o = cast(Uint32*)(p + y * s.pitch + x * 3);
    return *o;
}

Color get_pixel_col(SDL_Surface* s, int x, int y) {
    Color c;
    SDL_GetRGB(get_pixel(s, x, y), s.format, &c.r, &c.g, &c.b);
    return c;
}

Color get_col(SDL_Surface* s, Uint32 p) {
    Color c;
    SDL_GetRGB(p, s.format, &c.r, &c.g, &c.b);
    return c;
}

float ratio(int x, int y) {
    if (y == 0) {
        if (x == 0) {
            return -1;
        }
        else {
            return -2;
        }
    }
    else {
        return 1.0 * x / y;
    }
}

void print_color(Color c) {
    printf("%d %d %d\n", c.r, c.g, c.b);
}

void main() {
    SDL_Init(SDL_INIT_VIDEO);
    SDL_Surface* s = SDL_LoadBMP(`source.bmp`);
    SDL_Surface* t = SDL_LoadBMP(`target.bmp`);
    /*
    int[int] histogram;
    for (int y = 0; y < 600; y++) {
        for (int x = 0; x < 600; x++) {
            Color c = get_pixel_col(t, x, y);
            int p = c.r + c.g * 256 + c.b * 256 * 256;
            if (p in histogram) {
                histogram[p]++;
            }
            else {
                histogram[p] = 1;
            }
        }
    }
    foreach (k, v; histogram) {
        printf("%d ", v);
        printf("%d %d %d\n", k % 256, k / 256 % 256, k / 256 / 256);
        //print_color(get_col(t, k));
    }
    return;
    */
    for (int i = 0; i < 600; i++) {
        printf("%d ", i);
        //print_color(get_pixel_col(t, 0, i));
        print_color(get_pixel_col(t, i, 300));
    }
    for (int y = 0; y < 600; y++) {
        for (int x = 0; x < 600; x++) {
            Color sc = get_pixel_col(s, x, y);
            Color tc = get_pixel_col(t, x, y);
            float r = ratio(tc.r, sc.r);
            float g = ratio(tc.g, sc.g);
            float b = ratio(tc.b, sc.b);
            printf("%f %f %f\n", r, g, b);
        }
    }
}
