import SDL;
import std.file;
import std.math;

struct Color {
    Uint8 r, g, b;
}

Uint32 get_pixel(SDL_Surface* s, int x, int y) {
    Uint8* p = cast(Uint8*)s.pixels;
    Uint32* o = cast(Uint32*)(p + y * s.pitch + x * 3);
    return *o;
}

void set_pixel(SDL_Surface* s, Uint32 v, int x, int y) {
    Uint8* p = cast(Uint8*)s.pixels;
    Uint32* o = cast(Uint32*)(p + y * s.pitch + x * 3);
    *o = v;
}

Color get_pixel_col(SDL_Surface* s, int x, int y) {
    Color c;
    SDL_GetRGB(get_pixel(s, x, y), s.format, &c.r, &c.g, &c.b);
    return c;
}

Color get_col(SDL_Surface* s, Uint32 p) {
    Color c;
    SDL_GetRGB(p, s.format, &c.r, &c.g, &c.b);
    return c;
}

void print_color(Color c) {
    printf("%d %d %d\n", c.r, c.g, c.b);
}

void main() {
    SDL_Init(SDL_INIT_VIDEO);
    SDL_Surface* s = SDL_LoadBMP(`endo.bmp`);
    SDL_Surface* t = SDL_LoadBMP(`target.bmp`);
    int score = 0;
    for (int y = 0; y < 600; y++) {
        for (int x = 0; x < 600; x++) {
            Color sc = get_pixel_col(s, x, y);
            Color tc = get_pixel_col(t, x, y);
            //printf("(%d, %d)\n", x, y);
            //print_color(tc);
            //print_color(sc);
            //if (sc.r == tc.r && sc.g == tc.g && (sc.b == tc.b || sc.b==0)) {
            if (sc.r == tc.r && sc.g == tc.g && sc.b == tc.b) {
            //if (get_pixel(t, x, y) == get_pixel(s, x, y)) {
            //if (abs(sc.r - tc.r) < 2 && abs(sc.g - tc.g) < 2 && abs(sc.b - tc.b_ < 2) {
                set_pixel(s, 0, x, y);
            }
            else {
                score += 10;
            }
        }
    }
    printf("PICT: %d\n", score);
    int code_size = std.file.read(`prefix.dna`).length;
    printf("SIZE: %d\n", code_size);
    score += code_size;
    printf("ALL: %d\n", score);
    SDL_SaveBMP(s, `score.bmp`);
}
