import util;
import std.file;
import std.date;
import std.gc;
import std.c.string;
import std.string;
import std.stdio;
import std.c.stdlib;

uint i, last_i;
char[] dna;
int rnacnt;
char[] rna;
int cnt;
int cnt100_test;
int verbose;

int INT_LEN = 4;

char[] encode_int(int v) {
    char[] r = new char[INT_LEN];
    for (int j = 0; j < INT_LEN; j++) {
        r[j] = (v & 255);
        v >>= 8;
    }
    return r;
}

int decode_int(char[] r) {
    assert(r.length == INT_LEN);
    int v = 0;
    for (int j = 0; j < INT_LEN; j++) {
        v |= cast(int)(r[j]) << 8 * j;
    }
    return v;
}

char[] encode_str(char[] s) {
    return encode_int(s.length) ~ s;
}

void append_str(inout char[] s, char[] v) {
    foreach (char c; v) {
        s ~= c;
    }
}

int nat() {
    switch (dna[i++]) {
    case 'P': {
        return 0;
    }
    case 'I':
    case 'F': {
        return nat() * 2;
    }
    case 'C': {
        return nat() * 2 + 1;
    }
    }
}

int nat_i(char[] s, inout int i) {
    switch (s[i++]) {
    case 'P': {
        return 0;
    }
    case 'I':
    case 'F': {
        return nat_i(s, i) * 2;
    }
    case 'C': {
        return nat_i(s, i) * 2 + 1;
    }
    }
}

char[] consume_int() {
    int start_i = i;
    while (dna[i++] != 'P') {}
    return dna[start_i..i];
}

char[] consume_str() {
    int start_i = i;
    while (true) {
        if (dna[i++] == 'I') {
            if (dna[i] != 'C') {
                i--;
                return dna[start_i..i] ~ "X";
            }
        }
    }
}

char[] consts_i(char[] s, inout int i) {
    char[] r;
    while (true) {
        switch (s[i]) {
        case 'C': {
            r ~= 'I';
            break;
        }
        case 'F': {
            r ~= 'C';
            break;
        }
        case 'P': {
            r ~= 'F';
            break;
        }
        case 'I': {
            if (s[++i] == 'C') {
                r ~= 'P';
                break;
            }
            else {
                writefln(s[i..$]);
                assert(false);
            }
        }
        case 'X': {
            i++;
            return r;
        }
        }
        i++;
    }
    //return r;
}

char[] consts() {
    char[] r;
    while (true) {
        switch(dna[i++]) {
        case 'C': {
            r ~= 'I';
            break;
        }
        case 'F': {
            r ~= 'C';
            break;
        }
        case 'P': {
            r ~= 'F';
            break;
        }
        case 'I': {
            if (dna[i++] == 'C') {
                r ~= 'P';
            }
            else {
                i -= 2;
                return r;
            }
        }
        }
    }
}

void addrna() {
    /*
    if (rnacnt == 13673) {
        std.file.write(`last_dark.dna`, get_dna);
        exit(0);
    }
    */
    if (verbose) {
        printf("RNA: %.*s\n", dna[i..i+7]);
    }
    rnacnt++;
    rna ~= dna[i..i+7];
    i += 7;
}

char[] pattern() {
    char[] p;
    int lvl = 0;
    while (true) {
        switch (dna[i++]) {
        case 'C': {
            p ~= 'I';
            break;
        }
        case 'F': {
            p ~= 'C';
            break;
        }
        case 'P': {
            p ~= 'F';
            break;
        }
        case 'I': {
            switch (dna[i++]) {
            case 'C': {
                p ~= 'P';
                break;
            }
            case 'P': {
                p ~= '!';
                /*
                int num = nat();
                append_str(p, encode_int(num));
                */
                p ~= consume_int();
                break;
            }
            case 'F': {
                // three base!
                i++;
                p ~= '?';
                p ~= consume_str();
                //p ~= encode_str(consts());
                break;
            }
            case 'I': {
                switch (dna[i++]) {
                case 'P': {
                    lvl++;
                    p ~= '(';
                    break;
                }
                case 'C':
                case 'F': {
                    if (lvl == 0) return p;
                    else {
                        lvl--;
                        p ~= ')';
                    }
                    break;
                }
                case 'I': {
                    addrna();
                    break;
                }
                }
                break;
            }
        }
        }
        }
    }
    return p;
}

char[] templ() {
    char[] p;
    while (i < dna.length) {
        switch (dna[i++]) {
        case 'C': {
            p ~= 'I';
            break;
        }
        case 'F': {
            p ~= 'C';
            break;
        }
        case 'P': {
            p ~= 'F';
            break;
        }
        case 'I': {
            switch (dna[i++]) {
            case 'C': {
                p ~= 'P';
                break;
            }
            case 'F':
            case 'P': {{
                p ~= '~';
                p ~= consume_int();
                p ~= consume_int();
                /*
                append_str(p, encode_int(nat()));
                append_str(p, encode_int(nat()));
                */
                break;
            }
            case 'I': {
                switch (dna[i++]) {
                case 'C':
                case 'F': {
                    return p;
                }
                case 'P': {
                    p ~= '|';
                    p ~= consume_int();
                    //append_str(p, encode_int(nat()));
                    break;
                }
                case 'I': {
                    addrna();
                    break;
                }
                }
                break;
            }
        }
        }
        }
        }
    }
    return p;
}

char[] asnat(int n) {
    char[] r;
    while (n) {
        if (n & 1) {
            r ~= 'C';
        }
        else {
            r ~= 'I';
        }
        n >>= 1;
    }
    return r ~ 'P';
}

char[] asnat_r(int n) {
    if (n == 0) {
        return "P";
    }
    else if ((n & 1) == 0) {
        return "I" ~ asnat_r(n >> 1);
    }
    else {
        return "C" ~ asnat_r(n >> 1);
    }
}

char[] quote(char[] d) {
    char[] r;
    for (int j = 0; j < d.length; j++) {
        switch (d[j]) {
        case 'I': {
            r ~= 'C';
            break;
        }
        case 'C': {
            r ~= 'F';
            break;
        }
        case 'F': {
            r ~= 'P';
            break;
        }
        case 'P': {
            r ~= "IC";
            break;
        }
        }
    }
    return r;
}

char[] quote4(char[] d) {
    char[] r;
    for (int j = 0; j < d.length; j++) {
        switch (d[j]) {
        case 'I': {
            r ~= "IC";
            break;
        }
        case 'C': {
            r ~= "CF";
            break;
        }
        case 'F': {
            r ~= "FP";
            break;
        }
        case 'P': {
            r ~= "PIC";
            break;
        }
        }
    }
    delete d;
    return r;
}

char[] quote_r(char[] d) {
    if (d.length == 0) {
        return "";
    }
    switch (d[0]) {
    case 'I':
        return "C" ~ quote_r(d[1..$]);
    case 'C':
        return "F" ~ quote_r(d[1..$]);
    case 'F':
        return "P" ~ quote_r(d[1..$]);
    case 'P':
        return "IC" ~ quote_r(d[1..$]);
    }
}

char[] protect(int l, char[] d) {
    /*
    while (l > 3) {
        l -= 4;
        d = quote4(d);
    }
    */
    while (l--) {
        d = quote(d);
    }
    return d;
}

char[] protect_r(int l, char[] d) {
    if (l == 0) {
        return d;
    }
    else {
        return protect_r(l-1, quote_r(d));
    }
}

void dna_replace(char[] t, int[2][] e) {
    //std.gc.disable();

    char[] rbuf;
    int ti = 0;
    while (ti < t.length) {
        switch (t[ti++]) {
        case 'I':
        case 'C':
        case 'F':
        case 'P': {
            rbuf ~= t[ti-1];
            break;
        }
        case '~': {
            /*
            int l = decode_int(t[ti..ti+INT_LEN]);
            ti += INT_LEN;
            int n = decode_int(t[ti..ti+INT_LEN]);
            ti += INT_LEN;
            */
            //printf("%.*s %d\n", t, ti);
            int l = nat_i(t, ti);
            //printf("%.*s %d %d\n", t, ti, l);
            int n = nat_i(t, ti);
            //printf("%.*s %d %d\n", t, ti, n);
            if (n < e.length) {
                /*
                if (l == 0 && e[n][1] - e[n][0] > 6000000) {
                    int k;
                    for (k = ti; k < t.length; k++) {
                        if (t[k] == '~') break;
                    }
                    if (k == t.length) {
                        printf("opt\n");
                        r ~= dna[e[n][0]..e[n][1]];
                    }
                    else {
                        r ~= dna[e[n][0]..e[n][1]];
                    }
                }
                else {
                */
                //printf("() %d %d\n", cnt, e[n][1] - e[n][0]);
                rbuf ~= protect(l, dna[e[n][0]..e[n][1]]);
                //}
            }
            else {
                //r ~= protect(l, "");
            }
            break;
        }
        case '|': {
            //int n = decode_int(t[ti..ti+INT_LEN]);
            int n = nat_i(t, ti);
            //ti += INT_LEN;
            if (n < e.length) {
                rbuf ~= asnat(e[n][1]-e[n][0]);
            }
            else {
                //r ~= asnat(0);
                rbuf ~= 'P';
            }
            break;
        }
        }
    }
    delete e;
    i = min(i, dna.length);
    //printf("matched!\n");

    //printf("%d\n", rbuf.length);
    if (rbuf.length < 8000000 && rbuf.length < i) {
        //printf("%.*s %d\n", dna, i);
        i -= rbuf.length;
        memcpy(dna.ptr+i, rbuf.ptr, rbuf.length);
        /*
        for (uint j = 0; j < rbuf.length; j++) {
            dna[i + j] = rbuf[j];
        }
        */
        delete rbuf;
        //assert(dna[i..$] == r ~ dna[i+r.length..$]);
        //printf("%.*s %d\n", dna[i..$], i);
        /*
        uint j;
        for (j = 0; j < r.length; j++) {
            dna[j] = r[j];
        }
        for (; i < dna.length; i++, j++) {
            dna[j] = dna[i];
        }
        dna.length = j;
        i = 0;
        */
    }
    else {
        /*
        int j = r.length;
        r.length = j + dna.length - i;
        for (int k = 0; k < dna.length - i; k++) {
            r[j+k] = dna[i+k];
        }
        */
        rbuf ~= dna[i..$];
        char[] tmp = dna;
        dna = rbuf;
        delete tmp;
        i = 0;
    }
    last_i = i;
    //printf("%d %.*s\n", get_dna.length, get_dna);

    //std.gc.enable();
}

bool dna_start_with(char[] s) {
    int l = s.length;
    for (int j = 0; j < l; j++) {
        if (dna[i+j] != s[j]) return false;
    }
    return true;
}

char[] pat_str(char[] pat) {
    char[] r;
    int pi = 0;
    while (pi < pat.length) {
        r ~= pat[pi];
        switch (pat[pi++]) {
        case '(':
        case ')':
        case 'I':
        case 'C':
        case 'F':
        case 'P': {
            break;
        }
        case '!': {
            int v = nat_i(pat, pi);
            r ~= std.string.toString(v);
            r ~= ' ';
            break;
        }
        case '?': {
            int l = decode_int(pat[pi..pi+INT_LEN]);
            pi += INT_LEN;
            char[] s = pat[pi..pi+l];
            r ~= s;
            r ~= ' ';
            break;
        }
        }
    }
    return r;
}

char[] pat_str2(char[] pat) {
    char[] r;
    int pi = 0;
    while (pi < pat.length) {
        r ~= pat[pi];
        switch (pat[pi++]) {
        case '(':
        case ')':
        case 'I':
        case 'C':
        case 'F':
        case 'P': {
            break;
        }
        case '!': {
            int v = nat_i(pat, pi);
            r ~= std.string.toString(v);
            r ~= ' ';
            break;
        }
        case '?': {
            char[] s = consts_i(pat, pi);
            r ~= s;
            r ~= ' ';
            break;
        }
        }
    }
    return r;
}

char[] templ_str(char[] t) {
    int ti = 0;
    char[] r;
    while (ti < t.length) {
        r ~= t[ti];
        switch (t[ti++]) {
        case 'I':
        case 'C':
        case 'F':
        case 'P': {
            break;
        }
        case '~': {
            //printf("%.*s %d\n", t, ti);
            int l = nat_i(t, ti);
            //printf("%.*s %d %d\n", t, ti, l);
            int n = nat_i(t, ti);
            r ~= std.string.toString(n);
            r ~= '_';
            r ~= std.string.toString(l);
            r ~= ' ';
            break;
        }
        case '|': {
            int n = nat_i(t, ti);
            r ~= std.string.toString(n);
            r ~= ' ';
            break;
        }
        }
    }
    return r;
}

void match_replace(char[] pat, char[] t) {
    //char[][] e;
    int[2][] e;
    int[] c;
    int pi = 0;
    int start_i = i;
    //printf("MATCH %.*s => %.*s\n", pat_str(pat), templ_str(t));
    if (verbose) printf("MATCH %.*s => %.*s\n", pat_str2(pat), templ_str(t));
    while (pi < pat.length) {
        switch (pat[pi++]) {
        case 'I':
        case 'C':
        case 'F':
        case 'P': {
            if (i < dna.length && dna[i] == pat[pi-1]) {
                i++;
                break;
            }
            else {
                i = start_i;
                if (verbose) printf("NOT match!\n");
                return;
            }
        }
        case '!': {
            //i += decode_int(pat[pi..pi+INT_LEN]);
            i += nat_i(pat, pi);
            //pi += INT_LEN;
            if (i > dna.length) {
                i = start_i;
                if (verbose) printf("NOT match!\n");
                return;
            }
            break;
        }
        case '?': {
            //printf("%.*s\n", pat[pi..$]);
            char[] s = consts_i(pat, pi);
            //printf("%.*s\n", pat[pi..$]);
            /*
            int l = decode_int(pat[pi..pi+INT_LEN]);
            pi += INT_LEN;
            char[] s = pat[pi..pi+l];
            pi += l;
            */
            assert(pi <= pat.length);
            int f = std.string.find(dna[i..$], s);
            if (f == -1) {
                i = start_i;
                if (verbose) printf("NOT match!\n");
                return;
            }
            i += f;
            /*
            while (i+l <= dna.length && dna[i..i+l] != s) {
                i++;
            }
            if (i+l >= dna.length) {
                i = start_i;
                if (verbose) printf("NOT match!\n");
                return;
            }
            */
            i += s.length;
            break;
        }
        case '(': {
            c ~= i;
            break;
        }
        case ')': {
            int s = c[$-1];
            //e ~= dna[s..i];
            e ~= [s, i];
            c.length = c.length - 1;
            break;
        }
        }
    }
    if (verbose) printf("match!\n");
    dna_replace(t, e);
}

void one_iteration() {
    //printf("pattern\n");
    //printf("PAT %.*s\n", get_dna);
    //printf("%d\n", get_dna_length);
    char[] p = pattern();
    //printf("template\n");
    //printf("TMP %.*s\n", get_dna);
    //printf("%d\n", get_dna_length);
    char[] t = templ();
    //printf("match replace\n");
    //printf("%d\n", get_dna_length);
    match_replace(p, t);
    //printf("%d\n", get_dna_length);

    delete p;
    delete t;
}

void dna_execute() {
    cnt = 0;
    d_time start_time = getUTCtime();
    try {
        while (true) {
            //printf("LAST %d\n", last_i);
            //printf("%d %.*s\n", cnt++, dna);
            if (cnt++ % 100 == 0 || verbose) {
                printf("%d DNA=%d, %d RNA=%d %d\n",
                       cnt, dna.length-i, get_dna_length(), rnacnt,
                       getUTCtime() - start_time);
                //if (cnt > 1000) return;
            }
            if (cnt % 100000 == 0) {
                printf("flushing RNA and DNA...\n");
                std.file.write(`tmp` ~ std.string.toString(cnt) ~ `.rna`, rna);
                std.file.write(`tmp` ~ std.string.toString(cnt) ~ `.dna`, get_dna);
            }
            //printf("%d\n", cnt++);

            one_iteration();

            if (cnt100_test && cnt == 100) {
                //return;
                //std.file.write(`o.dna`, get_dna);
                //return;
                assert(cast(char[])std.file.read(`100.dna`) == get_dna);
                printf("count %d assertion passed (%d)\n",
                       cnt, get_dna_length());
            }
        }
    }
    catch (Exception e) {
        printf("%.*s\n", e.toString());
        //printf("RNA: %.*s\n", rna);
        std.file.write(`endo.rna`, rna);
    }
}

char[] get_dna() {
    return dna[last_i..$];
}

int get_dna_length() {
    return dna.length - last_i;
}

void init() {
    dna = "";
    rnacnt = 0;
    last_i = i = 0;
}

int main(char[][] args) {
    init();
    dna = "IICC".dup;
    match_replace("(!ICP)(!ICP)", "~PCP~PP");
    printf("%.*s\n", get_dna);

    init();
    dna ~= "IIPIPICPIICIIPIPICPIICIIC";
    dna ~= "IFPCPIFPPIIC";
    dna ~= "IICC";
    dna_execute();

    init();
    dna ~= "CIF";
    assert("I" == consts());

    int tmp = 0;
    assert("I" == consts_i("CX".dup, tmp));

    init();
    //dna ~= "IFCIFIIPIFCIFIICIFCIFIIC";
    dna ~= "IFCIFIIPIFCIFIICIFCIFIIC";
    dna ~= "IFPPIFPPIIC";
    dna ~= "ICIPIFI";
    dna_execute();
    //printf("%.*s\n", get_dna);
    //assert("CICIFI" == get_dna);

    assert(10 == decode_int(encode_int(10)));
    assert(1000 == decode_int(encode_int(1000)));
    assert(255 == decode_int(encode_int(255)));
    assert(256 == decode_int(encode_int(256)));
    assert(0 == decode_int(encode_int(0)));

    //printf("%.*s\n", asnat(10000));
    //printf("%.*s\n", asnat_r(10000));
    assert(asnat(999) == asnat_r(999));
    assert(asnat(10000) == asnat_r(10000));
    assert(asnat(0) == "P");
    assert(asnat(1) == "CP");
    assert(asnat(2) == "ICP");
    assert(asnat(3) == "CCP");

    assert(protect(10, "ICFP") == protect_r(10, "ICFP"));
    assert(protect(1, "ICFP") == "CFPIC");
    assert(protect(2, "ICFP") == "FPICCF");

    tmp = 0;
    assert(nat_i("ICP", tmp) == 2);

    init();
    dna = "CIIC".dup;
    assert("I" == pattern());

    init();
    dna = "IIPIPICPIICICIIF".dup;
    assert("(!ICP)P" == pattern());

    init();
    dna = "ICCIFPPIICCFPC".dup;
    assert("PI~PP" == templ());

    init();
    // pattern  == (!2)P
    // template == PI~00
    // rest     == CFPC
    dna = "IIPIPICPIICICIIFICCIFPPIICCFPC".dup;
    dna_execute();
    printf("%.*s\n", get_dna);
    assert("PICFC" == get_dna);

    init();
    dna = "IIPIPIICPIICIICCIICFCFC".dup;
    dna_execute();
    assert("I" == get_dna);

    init();
    dna = "IIPIPICPIICICIIFICCIFCCCPPIICCFPC".dup;
    dna_execute();
    printf("%.*s\n", get_dna);
    assert("PIICCFCFFPC" == get_dna);

    init();
    dna = "IIPIPICPIICICIIFICCIFCCCPPIICCFPC".dup;
    dna_execute();
    assert("PIICCFCFFPC" == get_dna);
    //dna_execute();
    //assert("ICICCFI" == get_dna);

    //printf("%.*s\n", pattern());

    init();
    dna = "";
    if (args.length > 1 && args[1] == "-v") {
        verbose = 1;
        args = args[1..$];
    }
    if (args.length == 3 && args[1] == "-x") {
        dna ~= cast(char[])std.file.read(args[2]);
    }
    else {
        if (args.length > 1) {
            printf("use %.*s\n", args[1]);
            dna ~= cast(char[])std.file.read(args[1]);
        }
        else {
            cnt100_test = 1;
            //dna ~= cast(char[])std.file.read(`prefix.dna`);
        }
        dna ~= cast(char[])std.file.read(`endo.dna`);
    }
    //dna = "IIPIFFCPICICIICPIICIPPPICIIC" ~ cast(char[])std.file.read(`endo.dna`);
    dna_execute();
    //printf("%.*s\n", dna);

    return 0;
}
